package com.example.ellegadodepintia.exploradoresDePintia
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.objeto.ObjetoDeValor

class ResumenAdapter(private val resumenList: MutableList<ObjetoDeValor>) :
    RecyclerView.Adapter<ResumenAdapter.ResumenViewHolder>() {

    class ResumenViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val textoObjeto: TextView = itemView.findViewById(R.id.textoObjeto)
        val textoPrecio: TextView = itemView.findViewById(R.id.textoPrecio)
        val imagen: ImageView = itemView.findViewById(R.id.imagenObjeto)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ResumenViewHolder {
        val view = LayoutInflater.from(parent.context)
            .inflate(R.layout.resumen_item, parent, false)
        return ResumenViewHolder(view)
    }

    override fun onBindViewHolder(holder: ResumenViewHolder, position: Int) {
        val resumen = resumenList[position]
        resumen.nombre.also { holder.textoObjeto.text = it }
        ": 20".also { holder.textoPrecio.text = it }
        holder.imagen.setBackgroundResource(resumen.imagen)
    }

    override fun getItemCount(): Int {
        return resumenList.size
    }
}


