package com.example.ellegadodepintia.exploradoresDePintia.model.efecto

import android.graphics.drawable.AnimationDrawable
import android.os.Handler
import android.os.Looper
import android.widget.ImageView
import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState.context
import com.example.ellegadodepintia.exploradoresDePintia.model.Atributo

//TODO() Agregar inventario con restos de la reliquia
class EfectoDestruir(probabilidadExito: Int) : Efecto(probabilidadExito) {
    override fun ejecutar(): String {
        val probabilidad = (1..100).random()
        return if (probabilidad <= probabilidadExito) {
            val imagenProtagonista = context!!.findViewById<ImageView>(R.id.imagenProtagonista)

            imagenProtagonista?.setImageResource(R.drawable.protagonista_ataque_animation)
            val ataqueAnimation = imagenProtagonista?.drawable as? AnimationDrawable
            ataqueAnimation?.start()

            Handler(Looper.getMainLooper()).postDelayed({
                imagenProtagonista?.setImageResource(R.drawable.protagonista_idle_animation)
                val idleAnimation = imagenProtagonista?.drawable as? AnimationDrawable
                idleAnimation?.start()
            }, 750)

            val ataque = GameState.jugador.atributos[Atributo.Ataque]!!
            GameState.eventoActual.actualizarResistencia(-ataque)

            if(GameState.eventoActual.resistenciaActual > 0){
                "¡Cuidado, parece que la reliquia se está quebrando!"
            }else{
                GameState.eventoActual.actualizarFinalizado(true)
                "¡Qué has hecho, la reliquia se ha roto por completo!"
            }
        } else {
            "La reliquia ha resistido el golpe con éxito."
        }
    }
}
