package com.example.ellegadodepintia.repositorios

import com.example.ellegadodepintia.PlayerLeaderBoard
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.Jugador
import com.google.firebase.firestore.FirebaseFirestore

object RepositorioJugador {
    private val db by lazy { FirebaseFirestore.getInstance() }
    private lateinit var email: String

    fun cargarJugador(email: String) {
        RepositorioJugador.email = email
        db.collection("users").document(email).get().addOnSuccessListener {
            GameState.jugador = Jugador()
            GameState.jugador.monedas = (it.get("monedas") as Long).toInt()
        }
    }

    fun addJugador(email: String, username: String) {
        db.collection("users").document(email).set(
            hashMapOf("monedas" to 0,
                "username" to username)
        )
    }

    fun setMonedas(monedas: Int) {
        db.collection("users").document(email).set(
            hashMapOf("monedas" to monedas)
        )
    }

    fun cargarJugadores(callback: (List<PlayerLeaderBoard>) -> Unit) {
        db.collection("users")
            .get()
            .addOnSuccessListener { result ->
                val players = mutableListOf<PlayerLeaderBoard>()

                for (document in result) {
                    val name = document.getString("username").toString()
                    val score = document.getLong("monedas")?.toInt() ?: 0
                    players.add(
                        PlayerLeaderBoard(
                            0,
                            name,
                            score
                        )
                    )
                }
                players.sortByDescending { it.score }
                players.forEachIndexed { index, player ->
                    player.position = index + 1
                }

                callback(players)
            }
    }

}
